#!/usr/bin/env python
import cgi
import sre
import MySQLdb


USERNAME = 'USER'
PASSWORD = 'PASS'

con = MySQLdb.connect('localhost', USERNAME, PASSWORD, 'diglib')
cur = con.cursor()

def decode_html(html):
	s = sre.sub('&#([Xx]?)([0-9]+);', lambda m: unichr(int(m.group(2),
		(16, 10)[m.group(1) == ''])), html)
	return s

def print_go_back():
	print '<br/>'
	print '<a href="../search/">← Νέα αναζήτηση</a>'

def query_db(kind, query, mode = 'normal'):
	query = '%' + query + '%'
	if kind == 'all':
		if mode == 'normal':
			cur.execute('''
				SELECT *, MATCH (title, description, tableOfContents, subject)
				AGAINST (%s) AS score
				FROM courses WHERE
				MATCH (title, description, tableOfContents, subject)
				AGAINST (%s)''', (query, query))
		elif mode == 'boolean':
			cur.execute('''
				SELECT * FROM courses WHERE
				MATCH (title, description, tableOfContents, subject)
				AGAINST (%s IN BOOLEAN MODE)''', (query,))
	elif kind == 'desc':
		if mode == 'normal':
			cur.execute('''
				SELECT *, MATCH (title, description)
				AGAINST (%s) AS score
				FROM courses WHERE MATCH (title, description)
				AGAINST (%s)''', (query, query)
				)
		elif mode == 'boolean':
			cur.execute('''
				SELECT * FROM courses WHERE MATCH (title, description)
				AGAINST (%s IN BOOLEAN MODE)''', (query,)
				)
	elif kind == 'toc':
		if mode == 'normal':
			cur.execute('''
				SELECT *, MATCH (title, tableOfContents)
				AGAINST (%s) AS score
				FROM courses WHERE MATCH (title, tableOfContents)
				AGAINST (%s)''', (query, query)
				)
		elif mode == 'boolean':
			cur.execute('''
				SELECT * FROM courses WHERE MATCH (title, tableOfContents)
				AGAINST (%s IN BOOLEAN MODE)''', (query,)
				)
	elif kind == 'subj':
		if mode == 'normal':
			cur.execute('''
				SELECT *, MATCH (title, subject)
				AGAINST (%s) AS score
				FROM courses WHERE MATCH (title, subject)
				AGAINST (%s)''', (query, query)
				)
		elif mode == 'boolean':
			cur.execute('''
				SELECT *	FROM courses WHERE MATCH (title, tableOfContents)
				AGAINST (%s IN BOOLEAN MODE)''', (query,)
				)

	results = cur.fetchall()
	return results

def reduce_chars(text, max_chars):
	'''reduces text (if needed) to given max chars
	and adds ... in the end'''
	if not isinstance(text, str):
		return str(text)
	text = text.decode('utf-8')
	if len(text) > max_chars:
		text = text[:max_chars - 3] + '...'

	return text.encode('utf-8')

def print_inital_and_title_and_text(text):
	print '<html>'
	print '<head><title>%s</title><meta name="author" content="Nikos Kouremenos"/>' % text
	print '<style>'
	data = open('../html/search/site.css').read()
	print data
	print '</style></head>'
	print '<body>'
	print '<h2>%s</h2>' % text

def show_results(results, kind, query, mode):
	if kind == 'all':
		text = 'Αποτελέσματα για "%s"' % query
	elif kind == 'toc':
		text = 'Αποτελέσματα για "%s" στο πεδίο "%s"' % (query, 'Περιεχόμενα')
	elif kind == 'subj':
		text = 'Αποτελέσματα για "%s" στο πεδίο "%s"' % (query, 'Θέμα')
	elif kind == 'desc':
		text = 'Αποτελέσματα για "%s" στο πεδίο "%s"' % (query, 'Περιγραφή')
	print_inital_and_title_and_text(text)

	if results == ():
		print '<br/><h3>Δεν βρέθηκε κανένα αποτέλεσμα</h3>'
		print_go_back()
		return

	print '<table>'
	print '''
		<tr>
			<th>Τίτλος</th>
			<th>Περιγραφή</th>
			<th>Θέμα</th>
			<th>Περιεχόμενα</th>
		'''
	
	if mode == 'normal': # relevancy only on non-boolean
		print '<th>Σχετικότητα</th>'''
	print '</tr>'
		

	for result in results:
		title = result[2] # 2nd col is title
		# 11th col is identifier (holds relative link)
		identifier = result[11]
		abs_url = 'http://thalis.cs.unipi.gr/' + identifier
		desc = result[5] # 5th col is description
		toc = result[6] # 6th col is toc
		subject = result[9] # 9th col is subj
		
		if mode == 'normal':
			relevancy = result[12]
		else:
			relevancy = None
		
		title = reduce_chars(title, 350) # max 350 chars
		print '<tr>'
		print '<td><a href="' + abs_url + '">' + title + '</a></td>'
		
		for item in (desc, subject, toc, relevancy):
			if item is None:
				continue
			item = reduce_chars(item, 100) # max 100 chars
			print '<td>' + item + '</td>'
		print '</tr>'
	print '</table>'
	print_go_back()
	print '</body>'
	print '</html>'

def main():
	print 'Content-type: text/html; charset=UTF-8\n'

	form = cgi.FieldStorage()
	query = form.getlist('search_entry')
	if len(query) == 0:
		text = 'Το πεδίο "Ερώτηση" είναι Κενό!'
		print_inital_and_title_and_text(text)
		print_go_back()
		print '</body></html>'
		return
	else:
		query = query[0]
	kind = form.getlist('kind_of_search')[0]
	
	query = decode_html(query)
	if query.find('+') != -1 or query.find('-') != -1 or\
		query.find('*') != -1:
		# if we have + or - or *
		# search in boolean mode
		results = query_db(kind, query, mode = 'boolean')
		show_results(results, kind, query, mode = 'boolean')
	else:
		results = query_db(kind, query, mode = 'normal')
		show_results(results, kind, query, mode = 'normal')

main()
